#include <stdio.h>
#include <conio.h>
#include <stdlib.h>
#define MAX 7

int leng;

struct student
{
	long id;
	int grade;
	struct student* next_id;
	struct student* next_grade;
};


void create_list (struct student** head)
{
	struct student* b_last;
	struct student* last;
	int i;
	leng = MAX/2 + random(MAX/2);

	printf ("\n\nInput %d random id numbers: \n");
	b_last = *head; //b_last = before last

	for (i = 0; i < leng; i++)
	{
		last = (struct student*)malloc(sizeof(struct student));
		last->id = random(1000)+6000;
		last->grade = random(51)+50;
		last->next_id = NULL;
		last->next_grade = NULL;
		b_last->next_id = last;
		b_last->next_grade = last;
		b_last = last;
	}
}

void write_list (struct student* head)
{
	struct student* temp_id = head->next_id;
	struct student* temp_grade = head->next_grade;

	printf ("\nLIst by id numbers: \n");
	while(temp_id)
	{
		printf ("\nId: %ld\t%p", temp_id->id, temp_id->next_id);
		temp_id = temp_id->next_id;
	}
	printf ("\nLIst by grades: \n");
	while(temp_grade)
	{
		printf ("\nGrade: %d\t%p", temp_grade->grade, temp_grade->next_grade);
		temp_grade = temp_grade->next_grade;
	}
}

struct student* place (struct student* head, int indx)
{
	struct student* temp = head;
	int i;
	for (i = 0; i < indx; i++)
		temp = temp->next_id;
	return temp;
}

int place_id (struct student* head, int x)
{
	int i;
	struct student* temp;
	temp = head;

	for (i = 0; i < x; i++)
		temp = temp->next_id;
	return temp->id;
}

int bin_search (struct student* head, int leng, long x)
{
	int first = 1;
	int last = leng;
	int mid = (first+last)/2;

	while (first < last)
	{
		if (x < place_id (head, mid))
			last = mid;
		else
			first = mid+1;
		mid = (first+last)/2;
	}
	if (x == place_id (head, mid))
		return mid;
	else
		return first;
}

void insert (struct student* head, int leng, long x)
{
	struct student* temp;
	struct student* temp1;
	int new_indx;

	new_indx = bin_search (head, leng, x);
	if (new_indx == leng) return;
	temp = place (head, new_indx); //new position in the list
	temp1 = place (head, leng); //points to the last
	place (head, leng-1)->next_id = temp1->next_id;
	place (head, new_indx-1)->next_id = temp1;
	temp1->next_id = temp;
}

void binary_sort (struct student** head)
{
	struct student* temp;
	int i;

	printf ("\n\nThe list after sorting by id numbers:\n\n");
	temp = *head;
	for (i = 0; i <= leng; i++)
	{
		temp = place (*head, i);
		insert (*head, i, temp->id);
	}
}

void del_member (struct student** head)
{
	struct student *temp = *head;
	*head = (*head)->next_id;
        printf ("%p\t", temp);
	free(temp);

}

void del_list (struct student** head)
{
	printf("\n\nDeleting the list\n");
	while (*head)
		del_member (head);
}

void main()
{
	int leng;
	struct student* head;
	randomize();
 	head = (struct student*)malloc(sizeof(struct student));
	head->id = 0;
	head->grade = 0;

	create_list (&head);
	write_list (head);
	binary_sort(&head);
	write_list (head);
	del_list (&head);
}